package compiler.ast;

/**
 * Assignment. name = value
 */
public class Assign extends Node {
  private Symbol name;
  private Node value;

  public Assign(Symbol name, Node value) {
    super();
    this.name = name;
    this.value = value;
  }

  public Symbol getName() { return name; }
  public void setName(Symbol s) { name = s; }
  public Node getValue() { return value; }

  public <T> T accept(Visitor<T> v) { return v.visit(this); }
  public void accept(VoidVisitor v) { v.visit(this); }
}
