package compiler.ast;

/**
 * Binary Expressions. arg1 op arg2
 */
public class BinaryExp extends Node {
  private Node arg1, arg2;
  private BinaryOp op;

  public BinaryExp(BinaryOp op, Node arg1, Node arg2) {
    super();
    this.op = op;
    this.arg1 = arg1;
    this.arg2 = arg2;
  }

  public Node getArg1() { return arg1; }
  public Node getArg2() { return arg2; }
  public BinaryOp getOp() { return op; }

  public <T> T accept(Visitor<T> v) { return v.visit(this); }
  public void accept(VoidVisitor v) { v.visit(this); }
}
