package compiler.ast;

import java.util.Collections;
import java.util.ArrayList;
import java.util.List;

/**
 * Block of statements. s1; s2; s3; An empty list is useful for representing
 * noops.
 */
public class Block extends Node {
  private List<Node> stmts;

  public Block(List<Node> stmts) {
    super();
    this.stmts = stmts;
  }

  public Block() {
    super();
    this.stmts = new ArrayList<Node>();
  }

  public List<Node> getStmts() { return Collections.unmodifiableList(stmts); }

  public <T> T accept(Visitor<T> v) { return v.visit(this); }
  public void accept(VoidVisitor v) { v.visit(this); }
}
