package compiler.ast;

import java.util.Collections;
import java.util.List;

/**
 * Method Calls. name(a1, a2, a3, ...)
 */
public class Call extends Node {
  private Symbol name;
  private List<Node> actuals;

  public Call(Symbol name, List<Node> actuals) {
    super();
    this.name = name;
    this.actuals = actuals;
  }

  public Symbol getName() { return name; }
  public void setName(Symbol s) { name = s; }
  public List<Node> getActuals() {
    return Collections.unmodifiableList(actuals);
  }

  public <T> T accept(Visitor<T> v) { return v.visit(this); }
  public void accept(VoidVisitor v) { v.visit(this); }
}
