package compiler.ast;

/**
 * Call Statement. Used when a call is used only for its side-effect.
 * 
 *  call;
 */
public class CallStmt extends Node {
  private Call call;

  public CallStmt(Call call) {
    super();
    this.call = call;
  }

  public Call getCall() { return call; }

  public <T> T accept(Visitor<T> v) { return v.visit(this); }
  public void accept(VoidVisitor v) { v.visit(this); }
}

