package compiler.ast;

/**
 * If statement. if (cond) trueBranch else falseBranch
 * If you need to have an empty false branch just use an empty Block.
 */
public class If extends Node {
  private Node cond, trueBranch, falseBranch;

  public If(Node cond, Node trueBranch, Node falseBranch) {
    super();
    this.cond = cond;
    this.trueBranch = trueBranch;
    this.falseBranch = falseBranch;
  }

  public Node getCond() { return cond; }
  public Node getTrueBranch() { return trueBranch; }
  public Node getFalseBranch() { return falseBranch; }

  public <T> T accept(Visitor<T> v) { return v.visit(this); }
  public void accept(VoidVisitor v) { v.visit(this); }
}
