package compiler.ast;

/**
 * Abstract base class for all AST nodes.
 */
public abstract class Node {
  private Type type;

  public Node() { }
  public abstract <T> T accept(Visitor<T> v);
  public abstract void accept(VoidVisitor v);
  public final Type getType() { return type; }
  public final void setType(Type t) { type = t; }
}
