package compiler.ast;

import java.util.Collections;
import java.util.List;

/**
 * Method declaration. rType name(f1, f2, f3, ...) body
 */
public class ProcedureDecl extends Node {
  private Type rType;
  private Symbol name;
  private List<VarDecl> formals;
  private Node body;

  public ProcedureDecl(Type rType, Symbol name, List<VarDecl> formals, Node body) {
    super();
    this.rType = rType;
    this.name = name;
    this.formals = formals;
    this.body = body;
  }

  public Type getRType() { return rType; }
  public Symbol getName() { return name; }
  public void setName(Symbol s) { name = s; }
  public List<VarDecl> getFormals() {
    return Collections.unmodifiableList(formals);
  }
  public Node getBody() { return body; }

  public <T> T accept(Visitor<T> v) { return v.visit(this); }
  public void accept(VoidVisitor v) { v.visit(this); }
}
