package compiler.ast;

import java.util.Collections;
import java.util.List;

public class ProgramNode extends Node {
  private List<Node> variable_declarations;
  private List<Node> constant_declarations;
  private List<Node> procedure_declarations;
  
  public ProgramNode(List<Node> c, List<Node> v, List<Node> p) {
    super();
	variable_declarations=v;
	constant_declarations=c;
	procedure_declarations=p;
  }

  public List<Node> getVariableDeclarations() {
    return Collections.unmodifiableList(variable_declarations);
  }
  public List<Node> getConstantDeclarations() {
    return Collections.unmodifiableList(constant_declarations);
  }
  public List<Node> getProcedureDeclarations() {
    return Collections.unmodifiableList(procedure_declarations);
  }

  public <T> T accept(Visitor<T> v) { return v.visit(this); }
  public void accept(VoidVisitor v) { v.visit(this); }
}
