package compiler.ast;

/**
 * Unary Expressions. op arg
 */
public class UnaryExp extends Node {
  private Node arg;
  private UnaryOp op;

  public UnaryExp(UnaryOp op, Node arg) {
    super();
    this.op = op;
    this.arg = arg;
  }

  public Node getArg() { return arg; }
  public UnaryOp getOp() { return op; }

  public <T> T accept(Visitor<T> v) { return v.visit(this); }
  public void accept(VoidVisitor v) { v.visit(this); }
}

