package compiler.ast;

/**
 * Local or Formal Declaration. varType name
 */
public class VarDecl extends Node {
  private String name;
  private Type varType;

  public VarDecl(Type varType, String name) {
    super();
    this.name = name;
    this.varType = varType;
  }

  public String getName() { return name; }
  public Type getVarType() { return varType; }

  public <T> T accept(Visitor<T> v) { return v.visit(this); }
  public void accept(VoidVisitor v) { v.visit(this); }
  public String toString()
  {
     return " Declaration "+varType + " named " + name;
  }
}
