package compiler.ast;

public interface Visitor<T> {
  public T visit(Assign n);
  public T visit(BinaryExp e);
  public T visit(Block n);
  public T visit(Break n);
  public T visit(Call n);
  public T visit(CallStmt n);
  public T visit(ProgramNode n);
  public T visit(Continue n);
  public T visit(If n);
  public T visit(IntLiteral n);
  public T visit(ProcedureDecl n);
  public T visit(Return n);
  public T visit(UnaryExp e);
  public T visit(Var n);
  public T visit(VarDecl n);
  public T visit(While n);
}
