package compiler.ast;

/**
 * While Statement. while (cond) body
 */
public class While extends Node {
  private Node cond, body;

  public While(Node cond, Node body) {
    super();
    this.cond = cond;
    this.body = body;
  }

  public Node getCond() { return cond; }
  public Node getBody() { return body; }

  public <T> T accept(Visitor<T> v) { return v.visit(this); }
  public void accept(VoidVisitor v) { v.visit(this); }
}

